# phpDox - Source of QueryBuilderInterface.php

# Source of file QueryBuilderInterface.php

Size: 12,486 Bytes - Last Modified: 2020-04-23T17:55:58-04:00

## src/QueryBuilderInterface.php

1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432 433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456 457 458 459 460 461 462 463 464 465 466 467 468 469 470 471 472 473 474 475 476 477 478 479 480 481 482 483 484 485 486 487 488 489 490 491 492 493 494 495 496 497 498 499 500 501 502 503 504

    <?php declare(strict_types=1);

    /**

     * Query

     *

     * SQL Query Builder / Database Abstraction Layer

     *

     * PHP version 7.4

     *

     * @package     Query

     * @author      Timothy J. Warren <tim@timshomepage.net>

     * @copyright   2012 - 2020 Timothy J. Warren

     * @license     http://www.opensource.org/licenses/mit-license.html  MIT License

     * @link        https://git.timshomepage.net/aviat/Query

     * @version     3.0.0

     */

    namespace Query;

    use PDO;

    use PDOStatement;

    /**

     * Interface defining the Query Builder class

     *

     * @method affectedRows(): int

     * @method beginTransaction(): bool

     * @method commit(): bool

     * @method errorCode(): string

     * @method errorInfo(): array

     * @method exec(string $statement): int

     * @method getAttribute(int $attribute)

     * @method getColumns(string $table): array | null

     * @method getDbs(): array | null

     * @method getFks(string $table): array | null

     * @method getFunctions(): array | null

     * @method getIndexes(string $table): array | null

     * @method getLastQuery(): string

     * @method getProcedures(): array | null

     * @method getSchemas(): array | null

     * @method getSequences(): array | null

     * @method getSystemTables(): array | null

     * @method getTables(): array

     * @method getTriggers(): array | null

     * @method getTypes(): array | null

     * @method getUtil(): \Query\Drivers\AbstractUtil

     * @method getVersion(): string

     * @method getViews(): array | null

     * @method inTransaction(): bool

     * @method lastInsertId(string $name = NULL): string

     * @method numRows(): int | null

     * @method prepare(string $statement, array $driver_options = []): PDOStatement

     * @method prepareExecute(string $sql, array $params): PDOStatement

     * @method prepareQuery(string $sql, array $data): PDOStatement

     * @method query(string $statement): PDOStatement

     * @method quote(string $string, int $parameter_type = PDO::PARAM_STR): string

     * @method rollback(): bool

     * @method setAttribute(int $attribute, $value): bool

     * @method setTablePrefix(string $prefix): void

     * @method truncate(string $table): PDOStatement

     */

    interface QueryBuilderInterface {

    	// --------------------------------------------------------------------------

    	// ! Select Queries

    	// --------------------------------------------------------------------------

    	/**

    	 * Specifies rows to select in a query

    	 *

    	 * @param string $fields

    	 * @return self

    	 */

    	public function select(string $fields): self;

    	/**

    	 * Selects the maximum value of a field from a query

    	 *

    	 * @param string $field

    	 * @param string|bool $as

    	 * @return self

    	 */

    	public function selectMax(string $field, $as=FALSE): self;

    	/**

    	 * Selects the minimum value of a field from a query

    	 *

    	 * @param string $field

    	 * @param string|bool $as

    	 * @return self

    	 */

    	public function selectMin(string $field, $as=FALSE): self;

    	/**

    	 * Selects the average value of a field from a query

    	 *

    	 * @param string $field

    	 * @param string|bool $as

    	 * @return self

    	 */

    	public function selectAvg(string $field, $as=FALSE): self;

    	/**

    	 * Selects the sum of a field from a query

    	 *

    	 * @param string $field

    	 * @param string|bool $as

    	 * @return self

    	 */

    	public function selectSum(string $field, $as=FALSE): self;

    	/**

    	 * Adds the 'distinct' keyword to a query

    	 *

    	 * @return self

    	 */

    	public function distinct(): self;

    	/**

    	 * Shows the query plan for the query

    	 *

    	 * @return self

    	 */

    	public function explain(): self;

    	/**

    	 * Specify the database table to select from

    	 *

    	 * Alias of `from` method to better match CodeIgniter 4

    	 *

    	 * @param string $tableName

    	 * @return self

    	 */

    	public function table(string $tableName): self;

    	/**

    	 * Specify the database table to select from

    	 *

    	 * @param string $tableName

    	 * @return self

    	 */

    	public function from(string $tableName): self;

    	// --------------------------------------------------------------------------

    	// ! 'Like' methods

    	// --------------------------------------------------------------------------

    	/**

    	 * Creates a Like clause in the sql statement

    	 *

    	 * @param string $field

    	 * @param mixed $values

    	 * @param string $pos

    	 * @return self

    	 */

    	public function like(string $field, $values, string $pos=LikeType::BOTH): self;

    	/**

    	 * Generates an OR Like clause

    	 *

    	 * @param string $field

    	 * @param mixed $values

    	 * @param string $pos

    	 * @return self

    	 */

    	public function orLike(string $field, $values, string $pos=LikeType::BOTH): self;

    	/**

    	 * Generates a NOT LIKE clause

    	 *

    	 * @param string $field

    	 * @param mixed $values

    	 * @param string $pos

    	 * @return self

    	 */

    	public function notLike(string $field, $values, string $pos=LikeType::BOTH): self;

    	/**

    	 * Generates a OR NOT LIKE clause

    	 *

    	 * @param string $field

    	 * @param mixed $values

    	 * @param string $pos

    	 * @return self

    	 */

    	public function orNotLike(string $field, $values, string $pos=LikeType::BOTH): self;

    	// --------------------------------------------------------------------------

    	// ! Having methods

    	// --------------------------------------------------------------------------

    	/**

    	 * Generates a 'Having' clause

    	 *

    	 * @param mixed $key

    	 * @param mixed $values

    	 * @return self

    	 */

    	public function having($key, $values=[]): self;

    	/**

    	 * Generates a 'Having' clause prefixed with 'OR'

    	 *

    	 * @param mixed $key

    	 * @param mixed $values

    	 * @return self

    	 */

    	public function orHaving($key, $values=[]): self;

    	// --------------------------------------------------------------------------

    	// ! 'Where' methods

    	// --------------------------------------------------------------------------

    	/**

    	 * Specify condition(s) in the where clause of a query

    	 * Note: this function works with key / value, or a

    	 * passed array with key / value pairs

    	 *

    	 * @param mixed $key

    	 * @param mixed $values

    	 * @param bool $escape

    	 * @return self

    	 */

    	public function where($key, $values=[], $escape = NULL): self;

    	/**

    	 * Where clause prefixed with "OR"

    	 *

    	 * @param string $key

    	 * @param mixed $values

    	 * @return self

    	 */

    	public function orWhere($key, $values=[]): self;

    	/**

    	 * Where clause with 'IN' statement

    	 *

    	 * @param mixed $field

    	 * @param mixed $values

    	 * @return self

    	 */

    	public function whereIn($field, $values=[]): self;

    	/**

    	 * Where in statement prefixed with "or"

    	 *

    	 * @param string $field

    	 * @param mixed $values

    	 * @return self

    	 */

    	public function orWhereIn($field, $values=[]): self;

    	/**

    	 * WHERE NOT IN (FOO) clause

    	 *

    	 * @param string $field

    	 * @param mixed $values

    	 * @return self

    	 */

    	public function whereNotIn($field, $values=[]): self;

    	/**

    	 * OR WHERE NOT IN (FOO) clause

    	 *

    	 * @param string $field

    	 * @param mixed $values

    	 * @return self

    	 */

    	public function orWhereNotIn($field, $values=[]): self;

    	// --------------------------------------------------------------------------

    	// ! Other Query Modifier methods

    	// --------------------------------------------------------------------------

    	/**

    	 * Sets values for inserts / updates / deletes

    	 *

    	 * @param mixed $key

    	 * @param mixed $values

    	 * @return self

    	 */

    	public function set($key, $values = NULL): self;

    	/**

    	 * Creates a join phrase in a compiled query

    	 *

    	 * @param string $table

    	 * @param string $condition

    	 * @param string $type

    	 * @return self

    	 */

    	public function join(string $table, string $condition, string $type=JoinType::INNER): self;

    	/**

    	 * Group the results by the selected field(s)

    	 *

    	 * @param mixed $field

    	 * @return self

    	 */

    	public function groupBy($field): self;

    	/**

    	 * Order the results by the selected field(s)

    	 *

    	 * @param string $field

    	 * @param string $type

    	 * @return self

    	 */

    	public function orderBy(string $field, string $type=''): self;

    	/**

    	 * Set a limit on the current sql statement

    	 *

    	 * @param int $limit

    	 * @param int|null $offset

    	 * @return self

    	 */

    	public function limit(int $limit, ?int $offset=NULL): self;

    	// --------------------------------------------------------------------------

    	// ! Query Grouping Methods

    	// --------------------------------------------------------------------------

    	/**

    	 * Adds a paren to the current query for query grouping

    	 *

    	 * @return self

    	 */

    	public function groupStart(): self;

    	/**

    	 * Adds a paren to the current query for query grouping,

    	 * prefixed with 'NOT'

    	 *

    	 * @return self

    	 */

    	public function notGroupStart(): self;

    	/**

    	 * Adds a paren to the current query for query grouping,

    	 * prefixed with 'OR'

    	 *

    	 * @return self

    	 */

    	public function orGroupStart(): self;

    	/**

    	 * Adds a paren to the current query for query grouping,

    	 * prefixed with 'OR NOT'

    	 *

    	 * @return self

    	 */

    	public function orNotGroupStart(): self;

    	/**

    	 * Ends a query group

    	 *

    	 * @return self

    	 */

    	public function groupEnd(): self;

    	// --------------------------------------------------------------------------

    	// ! Query execution methods

    	// --------------------------------------------------------------------------

    	/**

    	 * Select and retrieve all records from the current table, and/or

    	 * execute current compiled query

    	 *

    	 * @param string $table

    	 * @param int|null $limit

    	 * @param int|null $offset

    	 * @return PDOStatement

    	 */

    	public function get(string $table='', ?int $limit=NULL, ?int $offset=NULL): PDOStatement;

    	/**

    	 * Convenience method for get() with a where clause

    	 *

    	 * @param string $table

    	 * @param array $where

    	 * @param int|null $limit

    	 * @param int|null $offset

    	 * @return PDOStatement

    	 */

    	public function getWhere(string $table, $where=[], ?int $limit=NULL, ?int $offset=NULL): PDOStatement;

    	/**

    	 * Retrieve the number of rows in the selected table

    	 *

    	 * @param string $table

    	 * @return int

    	 */

    	public function countAll(string $table): int;

    	/**

    	 * Retrieve the number of results for the generated query - used

    	 * in place of the get() method

    	 *

    	 * @param string $table

    	 * @param bool $reset - Whether to keep the query after counting the results

    	 * @return int

    	 */

    	public function countAllResults(string $table='', bool $reset=TRUE): int;

    	/**

    	 * Creates an insert clause, and executes it

    	 *

    	 * @param string $table

    	 * @param mixed $data

    	 * @return PDOStatement

    	 */

    	public function insert(string $table, $data=[]): PDOStatement;

    	/**

    	 * Creates and executes a batch insertion query

    	 *

    	 * @param string $table

    	 * @param array $data

    	 * @return PDOStatement | null

    	 */

    	public function insertBatch(string $table, $data=[]): ?PDOStatement;

    	/**

    	 * Creates an update clause, and executes it

    	 *

    	 * @param string $table

    	 * @param mixed $data

    	 * @return PDOStatement

    	 */

    	public function update(string $table, $data=[]): PDOStatement;

    	/**

    	 * Creates a batch update, and executes it.

    	 * Returns the number of affected rows

    	 *

    	 * @param string $table The table to update

    	 * @param array $data an array of update values

    	 * @param string $where The where key

    	 * @return int|null

    	 */

    	public function updateBatch(string $table, array $data, string $where): ?int;

    	/**

    	 * Deletes data from a table

    	 *

    	 * @param string $table

    	 * @param mixed $where

    	 * @return PDOStatement

    	 */

    	public function delete(string $table, $where=''): PDOStatement;

    	// --------------------------------------------------------------------------

    	// ! SQL Returning Methods

    	// --------------------------------------------------------------------------

    	/**

    	 * Returns the generated 'select' sql query

    	 *

    	 * @param string $table

    	 * @param bool $reset

    	 * @return string

    	 */

    	public function getCompiledSelect(string $table='', bool $reset=TRUE): string;

    	/**

    	 * Returns the generated 'insert' sql query

    	 *

    	 * @param string $table

    	 * @param bool $reset

    	 * @return string

    	 */

    	public function getCompiledInsert(string $table, bool $reset=TRUE): string;

    	/**

    	 * Returns the generated 'update' sql query

    	 *

    	 * @param string $table

    	 * @param bool $reset

    	 * @return string

    	 */

    	public function getCompiledUpdate(string $table='', bool $reset=TRUE): string;

    	/**

    	 * Returns the generated 'delete' sql query

    	 *

    	 * @param string $table

    	 * @param bool $reset

    	 * @return string

    	 */

    	public function getCompiledDelete(string $table='', bool $reset=TRUE): string;

    	// --------------------------------------------------------------------------

    	// ! Miscellaneous Methods

    	// --------------------------------------------------------------------------

    	/**

    	 * Clear out the class variables, so the next query can be run

    	 *

    	 * @return void

    	 */

    	public function resetQuery(): void;

    }

    // End of QueryBuilderInterface.php